import random
random.seed("basic04/different")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 1, 2])

    def generate_min_tests(self):
        self.print_test([1])
        self.print_test([1, 2])
        self.print_test([1, 1])
                                                              
    def generate_hand_tests(self):
        self.print_test([4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4])
        self.print_test([1, 3, 2, 1, 2, 1, 3])

    def generate_random_test(self, maxn, maxx):
        a = []
        for i in range(maxn):
            a.append(random.randint(1, maxx))
        self.print_test(a)                   

    def generate_max_tests(self, maxn, maxx):
        self.print_test([4] * 1000)
        self.print_test([1000] * 1000)

        x = random.randint(1, maxx)
        y = random.randint(1, maxx)
        a = [x] * (maxn // 2)
        b = [y] * (maxn // 2)

        c = []
        for el in a:
            c.append(el)
        for el in b:
            c.append(el)
        self.print_test(c)

        c = []
        for el in b:
            c.append(el)
        for el in a:
            c.append(el)
        self.print_test(c)
        
    def print_test(self, a):
        self.test_number += 1
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(a), file=test_file)
        random.shuffle(a)
        print(' '.join(str(element) for element in a), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()                            
        self.generate_min_tests()                          
        self.generate_hand_tests()                         

        maxn = 1000
        maxx = 1000
        ns = [3, 5, 10, 50, 100, 250, 500, maxn]
        xs = [10, 50, 100, 500, 1000]
        for n in ns:
            for x in xs:
                self.generate_random_test(n, x)
        self.generate_max_tests(maxn, maxx)

import os, shutil
if os.path.exists('../tests'):
    print('Directory <<tests>> already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)