import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

public class Check implements Checker {

    boolean ensureLimits(int n, int from, int to) {
        return from <= n && n <= to;
    }


    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int cAns = ouf.nextInt();
        int jAns = ans.nextInt();
        if (cAns != jAns) {
            return new Outcome(Outcome.Type.WA, String.format("expected: %d, found: %d", jAns, cAns));
        }

        int n = inf.nextInt(), m = inf.nextInt();
        int[] districts = new int[n];
        for (int i = 0; i < n; ++i) {
            districts[i] = ouf.nextInt();
            if (!ensureLimits(districts[i], 1, cAns))
                return new Outcome(Outcome.Type.WA, String.format("Bad a[%d]", i + 1));
        }

        for (int i = 0; i < m; ++i) {
            int x = inf.nextInt();
            int y = inf.nextInt();
            int z = inf.nextInt();
            if (districts[x - 1] == districts[y - 1] && districts[y - 1] == districts[z - 1])
                return new Outcome(Outcome.Type.WA, "Part give correct k, but incorrect certificate");
            inf.nextLine();
        }
        return new Outcome(Outcome.Type.OK, String.format("Ok. k=%d", jAns));
    }
}
