@echo off

echo Compiling checker
g++ -O2 -static -o check.exe check.cpp

echo Compiling validator
g++ -O2 -std=c++0x -o validate.exe validate.cpp

echo Generating tests
if exist tests rd /s /q tests
pushd src
python gen.py
popd

echo Compiling main solution
g++ -O2  -Wall -Wextra -Wconversion -Werror -std=c++0x -o teleports_nb.exe teleports_nb.cpp


echo Generating answers
for %%j in (tests\??) do (
    echo Copying input for test %%j
    copy %%j teleports.in > nul

    echo Validating test %%j
    validate.exe < teleports.in
    if errorlevel 1 (
        echo Validator rejects test %%j
        goto end
    )    
    echo Validator accepts test %%j

    echo Running solution on test %%j
    teleports_nb.exe
    if errorlevel 1 (
        echo Solution failed on test %%j
        goto end
    )

    echo Running checker on test %%j        
    check.exe %%j teleports.out teleports.out
    if errorlevel 1 (
        echo Checker rejects main solution output on test %%j
        goto end
    )

    echo Saving answer for test %%j
    copy teleports.out %%j.a > nul
)


:end