import random
random.seed("basic04/weapons")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(1, [[1, 2], [1, 2]])
        self.print_test(1, [[1, 2], [1, 3], [2, 1]])
                                 
    def generate_min_tests(self):
        self.print_test(1, [[1, 2]])
        self.print_test(1, [[2, 1]])
        self.print_test(1, [[1, 1]])
                          
    def generate_hand_tests(self):
        self.print_test(2, [[2, 3], [3, 1], [4, 5], [3, 3], [1, 2]])
        self.print_test(1, [[1, 2], [1, 2], [1, 2], [1, 2], [1, 2]])

    def generate_random_test(self, maxn, maxx):
        n = maxn
        m = random.randint(1, n)
        a = []
        for i in range(n):
            ai = random.randint(1, maxx)
            bi = random.randint(1, maxx)
            a.append([ai, bi])
        self.print_test(m, a)

    def generate_max_tests(self, maxn, maxx):
        n = maxn
        m = 1
        a = []
        for i in range(n):
            if random.randint(1, 2) == 1:
                a.append([1, maxx])
            else:
                a.append([maxx, 1])
        self.print_test(m, a)

        m = 1
        a = []
        for i in range(n):
            a.append([1, maxx])
        self.print_test(m, a)

        m = 1
        a = []
        for i in range(n):
            a.append([maxx, 1])
        self.print_test(m, a)

        m = n
        a = []
        for i in range(n):
            a.append([maxx, 1])
        self.print_test(m, a)

    def print_test(self, m, a):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(a), m, file=test_file)
        print('\n'.join((str(element[0]) + ' ' + str(element[1])) for element in a), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        maxn = 10**5
        maxx = 10**4
        ns = [3, 5, 10, 100, 1000, 10**4, maxn // 2, maxn]
        xs = [10, 50, 100, 1000, maxx]
        for n in ns:
            for x in xs:
                self.generate_random_test(n, x)
        self.generate_max_tests(maxn, maxx)

    def generate_all_tests_argv(self, argv):
        pass            

if __name__ == "__main__":
    import os, shutil
    from sys import argv
    if os.path.exists('../tests'):
        print('Directory <<tests>> already exists')
        shutil.rmtree('../tests', ignore_errors=False, onerror=None)
    try:
        os.makedirs('../tests')
    except OSError:
        pass

    import time
    start = time.time()
    writer = TestGen()
    writer.generate_all_tests()
    #writer.generate_all_tests_argv(argv)
    finish = time.time()
    print('All tests were generated. Elapsed time: ', finish - start)
